Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/GaussianTransform.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/GaussianTransform.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/GaussianTransform.cs	(revision 4068)
@@ -19,191 +19,167 @@
 
 using System;
-using System.Collections.Generic;
+using System.Globalization;
 using System.IO;
-using System.Globalization;
-using System.Threading;
 
-namespace SVM
-{
+namespace SVM {
+  /// <summary>
+  /// A transform which learns the mean and variance of a sample set and uses these to transform new data
+  /// so that it has zero mean and unit variance.
+  /// </summary>
+  public class GaussianTransform : IRangeTransform {
+    private double[] _means;
+    private double[] _stddevs;
+
     /// <summary>
-    /// A transform which learns the mean and variance of a sample set and uses these to transform new data
-    /// so that it has zero mean and unit variance.
+    /// Determines the Gaussian transform for the provided problem.
     /// </summary>
-    public class GaussianTransform : IRangeTransform
-    {
-        private double[] _means;
-        private double[] _stddevs;
+    /// <param name="prob">The Problem to analyze</param>
+    /// <returns>The Gaussian transform for the problem</returns>
+    public static GaussianTransform Compute(Problem prob) {
+      int[] counts = new int[prob.MaxIndex];
+      double[] means = new double[prob.MaxIndex];
+      foreach (Node[] sample in prob.X) {
+        for (int i = 0; i < sample.Length; i++) {
+          means[sample[i].Index - 1] += sample[i].Value;
+          counts[sample[i].Index - 1]++;
+        }
+      }
+      for (int i = 0; i < prob.MaxIndex; i++) {
+        if (counts[i] == 0)
+          counts[i] = 2;
+        means[i] /= counts[i];
+      }
 
-        /// <summary>
-        /// Determines the Gaussian transform for the provided problem.
-        /// </summary>
-        /// <param name="prob">The Problem to analyze</param>
-        /// <returns>The Gaussian transform for the problem</returns>
-        public static GaussianTransform Compute(Problem prob)
-        {
-            int[] counts = new int[prob.MaxIndex];
-            double[] means = new double[prob.MaxIndex];
-            foreach (Node[] sample in prob.X)
-            {
-                for (int i = 0; i < sample.Length; i++)
-                {
-                    means[sample[i].Index-1] += sample[i].Value;
-                    counts[sample[i].Index-1]++;
-                }
-            }
-            for (int i = 0; i < prob.MaxIndex; i++)
-            {
-                if (counts[i] == 0)
-                    counts[i] = 2;
-                means[i] /= counts[i];
-            }
+      double[] stddevs = new double[prob.MaxIndex];
+      foreach (Node[] sample in prob.X) {
+        for (int i = 0; i < sample.Length; i++) {
+          double diff = sample[i].Value - means[sample[i].Index - 1];
+          stddevs[sample[i].Index - 1] += diff * diff;
+        }
+      }
+      for (int i = 0; i < prob.MaxIndex; i++) {
+        if (stddevs[i] == 0)
+          continue;
+        stddevs[i] /= (counts[i] - 1);
+        stddevs[i] = Math.Sqrt(stddevs[i]);
+      }
 
-            double[] stddevs = new double[prob.MaxIndex];
-            foreach (Node[] sample in prob.X)
-            {
-                for (int i = 0; i < sample.Length; i++)
-                {
-                    double diff = sample[i].Value - means[sample[i].Index - 1];
-                    stddevs[sample[i].Index - 1] += diff * diff;
-                }
-            }
-            for (int i = 0; i < prob.MaxIndex; i++)
-            {
-                if (stddevs[i] == 0)
-                    continue;
-                stddevs[i] /= (counts[i] - 1);
-                stddevs[i] = Math.Sqrt(stddevs[i]);
-            }
+      return new GaussianTransform(means, stddevs);
+    }
 
-            return new GaussianTransform(means, stddevs);
-        }
+    /// <summary>
+    /// Constructor.
+    /// </summary>
+    /// <param name="means">Means in each dimension</param>
+    /// <param name="stddevs">Standard deviation in each dimension</param>
+    public GaussianTransform(double[] means, double[] stddevs) {
+      _means = means;
+      _stddevs = stddevs;
+    }
 
-        /// <summary>
-        /// Constructor.
-        /// </summary>
-        /// <param name="means">Means in each dimension</param>
-        /// <param name="stddevs">Standard deviation in each dimension</param>
-        public GaussianTransform(double[] means, double[] stddevs)
-        {
-            _means = means;
-            _stddevs = stddevs;
-        }
+    /// <summary>
+    /// Saves the transform to the disk.  The samples are not stored, only the 
+    /// statistics.
+    /// </summary>
+    /// <param name="stream">The destination stream</param>
+    /// <param name="transform">The transform</param>
+    public static void Write(Stream stream, GaussianTransform transform) {
+      TemporaryCulture.Start();
 
-        /// <summary>
-        /// Saves the transform to the disk.  The samples are not stored, only the 
-        /// statistics.
-        /// </summary>
-        /// <param name="stream">The destination stream</param>
-        /// <param name="transform">The transform</param>
-        public static void Write(Stream stream, GaussianTransform transform)
-        {
-            TemporaryCulture.Start();
+      StreamWriter output = new StreamWriter(stream);
+      output.WriteLine(transform._means.Length);
+      for (int i = 0; i < transform._means.Length; i++)
+        output.WriteLine("{0} {1}", transform._means[i], transform._stddevs[i]);
+      output.Flush();
 
-            StreamWriter output = new StreamWriter(stream);
-            output.WriteLine(transform._means.Length);
-            for (int i = 0; i < transform._means.Length; i++)
-                output.WriteLine("{0} {1}", transform._means[i], transform._stddevs[i]);
-            output.Flush();
+      TemporaryCulture.Stop();
+    }
 
-            TemporaryCulture.Stop();
-        }
+    /// <summary>
+    /// Reads a GaussianTransform from the provided stream.
+    /// </summary>
+    /// <param name="stream">The source stream</param>
+    /// <returns>The transform</returns>
+    public static GaussianTransform Read(Stream stream) {
+      TemporaryCulture.Start();
 
-        /// <summary>
-        /// Reads a GaussianTransform from the provided stream.
-        /// </summary>
-        /// <param name="stream">The source stream</param>
-        /// <returns>The transform</returns>
-        public static GaussianTransform Read(Stream stream)
-        {
-            TemporaryCulture.Start();
+      StreamReader input = new StreamReader(stream);
+      int length = int.Parse(input.ReadLine(), CultureInfo.InvariantCulture);
+      double[] means = new double[length];
+      double[] stddevs = new double[length];
+      for (int i = 0; i < length; i++) {
+        string[] parts = input.ReadLine().Split();
+        means[i] = double.Parse(parts[0], CultureInfo.InvariantCulture);
+        stddevs[i] = double.Parse(parts[1], CultureInfo.InvariantCulture);
+      }
 
-            StreamReader input = new StreamReader(stream);
-            int length = int.Parse(input.ReadLine(), CultureInfo.InvariantCulture);
-            double[] means = new double[length];
-            double[] stddevs = new double[length];
-            for (int i = 0; i < length; i++)
-            {
-                string[] parts = input.ReadLine().Split();
-                means[i] = double.Parse(parts[0], CultureInfo.InvariantCulture);
-                stddevs[i] = double.Parse(parts[1], CultureInfo.InvariantCulture);
-            }
+      TemporaryCulture.Stop();
 
-            TemporaryCulture.Stop();
+      return new GaussianTransform(means, stddevs);
+    }
 
-            return new GaussianTransform(means, stddevs);
-        }
+    /// <summary>
+    /// Saves the transform to the disk.  The samples are not stored, only the 
+    /// statistics.
+    /// </summary>
+    /// <param name="filename">The destination filename</param>
+    /// <param name="transform">The transform</param>
+    public static void Write(string filename, GaussianTransform transform) {
+      FileStream output = File.Open(filename, FileMode.Create);
+      try {
+        Write(output, transform);
+      }
+      finally {
+        output.Close();
+      }
+    }
 
-        /// <summary>
-        /// Saves the transform to the disk.  The samples are not stored, only the 
-        /// statistics.
-        /// </summary>
-        /// <param name="filename">The destination filename</param>
-        /// <param name="transform">The transform</param>
-        public static void Write(string filename, GaussianTransform transform)
-        {
-            FileStream output = File.Open(filename, FileMode.Create);
-            try
-            {
-                Write(output, transform);
-            }
-            finally
-            {
-                output.Close();
-            }
-        }
+    /// <summary>
+    /// Reads a GaussianTransform from the provided stream.
+    /// </summary>
+    /// <param name="filename">The source filename</param>
+    /// <returns>The transform</returns>
+    public static GaussianTransform Read(string filename) {
+      FileStream input = File.Open(filename, FileMode.Open);
+      try {
+        return Read(input);
+      }
+      finally {
+        input.Close();
+      }
+    }
 
-        /// <summary>
-        /// Reads a GaussianTransform from the provided stream.
-        /// </summary>
-        /// <param name="filename">The source filename</param>
-        /// <returns>The transform</returns>
-        public static GaussianTransform Read(string filename)
-        {
-            FileStream input = File.Open(filename, FileMode.Open);
-            try
-            {
-                return Read(input);
-            }
-            finally
-            {
-                input.Close();
-            }
-        }
+    #region IRangeTransform Members
 
-        #region IRangeTransform Members
+    /// <summary>
+    /// Transform the input value using the transform stored for the provided index.
+    /// </summary>
+    /// <param name="input">Input value</param>
+    /// <param name="index">Index of the transform to use</param>
+    /// <returns>The transformed value</returns>
+    public double Transform(double input, int index) {
+      index--;
+      if (_stddevs[index] == 0)
+        return 0;
+      double diff = input - _means[index];
+      diff /= _stddevs[index];
+      return diff;
+    }
+    /// <summary>
+    /// Transforms the input array.
+    /// </summary>
+    /// <param name="input">The array to transform</param>
+    /// <returns>The transformed array</returns>
+    public Node[] Transform(Node[] input) {
+      Node[] output = new Node[input.Length];
+      for (int i = 0; i < output.Length; i++) {
+        int index = input[i].Index;
+        double value = input[i].Value;
+        output[i] = new Node(index, Transform(value, index));
+      }
+      return output;
+    }
 
-        /// <summary>
-        /// Transform the input value using the transform stored for the provided index.
-        /// </summary>
-        /// <param name="input">Input value</param>
-        /// <param name="index">Index of the transform to use</param>
-        /// <returns>The transformed value</returns>
-        public double Transform(double input, int index)
-        {
-            index--;
-            if (_stddevs[index] == 0)
-                return 0;
-            double diff = input - _means[index];
-            diff /= _stddevs[index];
-            return diff;
-        }
-        /// <summary>
-        /// Transforms the input array.
-        /// </summary>
-        /// <param name="input">The array to transform</param>
-        /// <returns>The transformed array</returns>
-        public Node[] Transform(Node[] input)
-        {
-            Node[] output = new Node[input.Length];
-            for (int i = 0; i < output.Length; i++)
-            {
-                int index = input[i].Index;
-                double value = input[i].Value;
-                output[i] = new Node(index, Transform(value, index));
-            }
-            return output;
-        }
-
-        #endregion
-    }
+    #endregion
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Kernel.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Kernel.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Kernel.cs	(revision 4068)
@@ -1,226 +1,182 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 
-namespace SVM
-{
-    internal interface IQMatrix
-    {
-        float[] GetQ(int column, int len);
-        float[] GetQD();
-        void SwapIndex(int i, int j);
+namespace SVM {
+  internal interface IQMatrix {
+    float[] GetQ(int column, int len);
+    float[] GetQD();
+    void SwapIndex(int i, int j);
+  }
+
+  internal abstract class Kernel : IQMatrix {
+    private Node[][] _x;
+    private double[] _xSquare;
+
+    private KernelType _kernelType;
+    private int _degree;
+    private double _gamma;
+    private double _coef0;
+
+    public abstract float[] GetQ(int column, int len);
+    public abstract float[] GetQD();
+
+    public virtual void SwapIndex(int i, int j) {
+      _x.SwapIndex(i, j);
+
+      if (_xSquare != null) {
+        _xSquare.SwapIndex(i, j);
+      }
     }
 
-    internal abstract class Kernel : IQMatrix
-    {
-        private Node[][] _x;
-        private double[] _xSquare;
+    private static double powi(double value, int times) {
+      double tmp = value, ret = 1.0;
 
-        private KernelType _kernelType;
-        private int _degree;
-        private double _gamma;
-        private double _coef0;
+      for (int t = times; t > 0; t /= 2) {
+        if (t % 2 == 1) ret *= tmp;
+        tmp = tmp * tmp;
+      }
+      return ret;
+    }
 
-        public abstract float[] GetQ(int column, int len);
-        public abstract float[] GetQD();
+    public double KernelFunction(int i, int j) {
+      switch (_kernelType) {
+        case KernelType.LINEAR:
+          return dot(_x[i], _x[j]);
+        case KernelType.POLY:
+          return powi(_gamma * dot(_x[i], _x[j]) + _coef0, _degree);
+        case KernelType.RBF:
+          return Math.Exp(-_gamma * (_xSquare[i] + _xSquare[j] - 2 * dot(_x[i], _x[j])));
+        case KernelType.SIGMOID:
+          return Math.Tanh(_gamma * dot(_x[i], _x[j]) + _coef0);
+        case KernelType.PRECOMPUTED:
+          return _x[i][(int)(_x[j][0].Value)].Value;
+        default:
+          return 0;
+      }
+    }
 
-        public virtual void SwapIndex(int i, int j)
-        {
-            _x.SwapIndex(i, j);
+    public Kernel(int l, Node[][] x_, Parameter param) {
+      _kernelType = param.KernelType;
+      _degree = param.Degree;
+      _gamma = param.Gamma;
+      _coef0 = param.Coefficient0;
 
-            if (_xSquare != null)
-            {
-                _xSquare.SwapIndex(i, j);
-            }
+      _x = (Node[][])x_.Clone();
+
+      if (_kernelType == KernelType.RBF) {
+        _xSquare = new double[l];
+        for (int i = 0; i < l; i++)
+          _xSquare[i] = dot(_x[i], _x[i]);
+      } else _xSquare = null;
+    }
+
+    private static double dot(Node[] xNodes, Node[] yNodes) {
+      double sum = 0;
+      int xlen = xNodes.Length;
+      int ylen = yNodes.Length;
+      int i = 0;
+      int j = 0;
+      Node x = xNodes[0];
+      Node y = yNodes[0];
+      while (true) {
+        if (x._index == y._index) {
+          sum += x._value * y._value;
+          i++;
+          j++;
+          if (i < xlen && j < ylen) {
+            x = xNodes[i];
+            y = yNodes[j];
+          } else if (i < xlen) {
+            x = xNodes[i];
+            break;
+          } else if (j < ylen) {
+            y = yNodes[j];
+            break;
+          } else break;
+        } else {
+          if (x._index > y._index) {
+            ++j;
+            if (j < ylen)
+              y = yNodes[j];
+            else break;
+          } else {
+            ++i;
+            if (i < xlen)
+              x = xNodes[i];
+            else break;
+          }
         }
+      }
+      return sum;
+    }
 
-        private static double powi(double value, int times)
-        {
-            double tmp = value, ret = 1.0;
+    private static double computeSquaredDistance(Node[] xNodes, Node[] yNodes) {
+      Node x = xNodes[0];
+      Node y = yNodes[0];
+      int xLength = xNodes.Length;
+      int yLength = yNodes.Length;
+      int xIndex = 0;
+      int yIndex = 0;
+      double sum = 0;
 
-            for (int t = times; t > 0; t /= 2)
-            {
-                if (t % 2 == 1) ret *= tmp;
-                tmp = tmp * tmp;
-            }
-            return ret;
+      while (true) {
+        if (x._index == y._index) {
+          double d = x._value - y._value;
+          sum += d * d;
+          xIndex++;
+          yIndex++;
+          if (xIndex < xLength && yIndex < yLength) {
+            x = xNodes[xIndex];
+            y = yNodes[yIndex];
+          } else if (xIndex < xLength) {
+            x = xNodes[xIndex];
+            break;
+          } else if (yIndex < yLength) {
+            y = yNodes[yIndex];
+            break;
+          } else break;
+        } else if (x._index > y._index) {
+          sum += y._value * y._value;
+          if (++yIndex < yLength)
+            y = yNodes[yIndex];
+          else break;
+        } else {
+          sum += x._value * x._value;
+          if (++xIndex < xLength)
+            x = xNodes[xIndex];
+          else break;
         }
+      }
 
-        public double KernelFunction(int i, int j)
-        {
-            switch (_kernelType)
-            {
-                case KernelType.LINEAR:
-                    return dot(_x[i], _x[j]);
-                case KernelType.POLY:
-                    return powi(_gamma * dot(_x[i], _x[j]) + _coef0, _degree);
-                case KernelType.RBF:
-                    return Math.Exp(-_gamma * (_xSquare[i] + _xSquare[j] - 2 * dot(_x[i], _x[j])));
-                case KernelType.SIGMOID:
-                    return Math.Tanh(_gamma * dot(_x[i], _x[j]) + _coef0);
-                case KernelType.PRECOMPUTED:
-                    return _x[i][(int)(_x[j][0].Value)].Value;
-                default:
-                    return 0;
-            }
-        }
+      for (; xIndex < xLength; xIndex++) {
+        double d = xNodes[xIndex]._value;
+        sum += d * d;
+      }
 
-        public Kernel(int l, Node[][] x_, Parameter param)
-        {
-            _kernelType = param.KernelType;
-            _degree = param.Degree;
-            _gamma = param.Gamma;
-            _coef0 = param.Coefficient0;
+      for (; yIndex < yLength; yIndex++) {
+        double d = yNodes[yIndex]._value;
+        sum += d * d;
+      }
 
-            _x = (Node[][])x_.Clone();
+      return sum;
+    }
 
-            if (_kernelType == KernelType.RBF)
-            {
-                _xSquare = new double[l];
-                for (int i = 0; i < l; i++)
-                    _xSquare[i] = dot(_x[i], _x[i]);
-            }
-            else _xSquare = null;
-        }
-
-        private static double dot(Node[] xNodes, Node[] yNodes)
-        {
-            double sum = 0;
-            int xlen = xNodes.Length;
-            int ylen = yNodes.Length;
-            int i = 0;
-            int j = 0;
-            Node x = xNodes[0];
-            Node y = yNodes[0];
-            while (true)
-            {
-                if (x._index == y._index)
-                {
-                    sum += x._value * y._value;
-                    i++;
-                    j++;
-                    if (i < xlen && j < ylen)
-                    {
-                        x = xNodes[i];
-                        y = yNodes[j];
-                    }
-                    else if (i < xlen)
-                    {
-                        x = xNodes[i];
-                        break;
-                    }
-                    else if (j < ylen)
-                    {
-                        y = yNodes[j];
-                        break;
-                    }
-                    else break;
-                }
-                else
-                {
-                    if (x._index > y._index)
-                    {
-                        ++j;
-                        if (j < ylen)
-                            y = yNodes[j];
-                        else break;
-                    }
-                    else
-                    {
-                        ++i;
-                        if (i < xlen)
-                            x = xNodes[i];
-                        else break;
-                    }
-                }
-            }
-            return sum;
-        }
-
-        private static double computeSquaredDistance(Node[] xNodes, Node[] yNodes)
-        {
-            Node x = xNodes[0];
-            Node y = yNodes[0];
-            int xLength = xNodes.Length;
-            int yLength = yNodes.Length;
-            int xIndex = 0;
-            int yIndex = 0;
-            double sum = 0;
-
-            while (true)
-            {
-                if (x._index == y._index)
-                {
-                    double d = x._value - y._value;
-                    sum += d * d;
-                    xIndex++;
-                    yIndex++;
-                    if (xIndex < xLength && yIndex < yLength)
-                    {
-                        x = xNodes[xIndex];
-                        y = yNodes[yIndex];
-                    }
-                    else if(xIndex < xLength){
-                        x = xNodes[xIndex];
-                        break;
-                    }
-                    else if(yIndex < yLength){
-                        y = yNodes[yIndex];
-                        break;
-                    }else break;
-                }
-                else if (x._index > y._index)
-                {
-                    sum += y._value * y._value;
-                    if (++yIndex < yLength)
-                        y = yNodes[yIndex];
-                    else break;
-                }
-                else
-                {
-                    sum += x._value * x._value;
-                    if (++xIndex < xLength)
-                        x = xNodes[xIndex];
-                    else break;
-                }
-            }
-
-            for (; xIndex < xLength; xIndex++)
-            {
-                double d = xNodes[xIndex]._value;
-                sum += d * d;
-            }
-
-            for (; yIndex < yLength; yIndex++)
-            {
-                double d = yNodes[yIndex]._value;
-                sum += d * d;
-            }
-
-            return sum;
-        }
-
-        public static double KernelFunction(Node[] x, Node[] y, Parameter param)
-        {
-            switch (param.KernelType)
-            {
-                case KernelType.LINEAR:
-                    return dot(x, y);
-                case KernelType.POLY:
-                    return powi(param.Degree * dot(x, y) + param.Coefficient0, param.Degree);
-                case KernelType.RBF:
-                    {
-                        double sum = computeSquaredDistance(x, y);
-                        return Math.Exp(-param.Gamma * sum);
-                    }
-                case KernelType.SIGMOID:
-                    return Math.Tanh(param.Gamma * dot(x, y) + param.Coefficient0);
-                case KernelType.PRECOMPUTED:
-                    return x[(int)(y[0].Value)].Value;
-                default:
-                    return 0;
-            }
-        }
+    public static double KernelFunction(Node[] x, Node[] y, Parameter param) {
+      switch (param.KernelType) {
+        case KernelType.LINEAR:
+          return dot(x, y);
+        case KernelType.POLY:
+          return powi(param.Degree * dot(x, y) + param.Coefficient0, param.Degree);
+        case KernelType.RBF: {
+            double sum = computeSquaredDistance(x, y);
+            return Math.Exp(-param.Gamma * sum);
+          }
+        case KernelType.SIGMOID:
+          return Math.Tanh(param.Gamma * dot(x, y) + param.Coefficient0);
+        case KernelType.PRECOMPUTED:
+          return x[(int)(y[0].Value)].Value;
+        default:
+          return 0;
+      }
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Model.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Model.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Model.cs	(revision 4068)
@@ -21,6 +21,4 @@
 using System;
 using System.IO;
-using System.Threading;
-using System.Globalization;
 
 namespace SVM {
